#ifndef GMCSDK_DEF_H
#define GMCSDK_DEF_H


const unsigned int LEN_ID = 64;
const unsigned int LEN_NAME = 64;
const unsigned int LEN_SYMBOL = 32;
const unsigned int LEN_INFO = 128;
const unsigned int LEN_EXCHANGE = 8;
const unsigned int LEN_ISO_DATATIME = 36;
const unsigned int LEN_FREQUENCY = 8;
const unsigned int DEPTH_OF_QUOTE = 10;
const unsigned int LEN_PARAM = 256;
const unsigned int LEN_COMMENT = 256;
const unsigned int LEN_MAX_ORDER_QUEUE = 50;
const unsigned int LEN_TYPE = 8;
const unsigned int LEN_TIME_LIST = 128;

#define IN_AT_OUT_NO_SPECIFIED 2147483647

enum StrategyMode
{
	MODE_UNDEF = 0,          //δ壬 Բ
	MODE_LIVE = 1,           //ʵģʽ
	MODE_BACKTEST = 2        //زģʽ
};

enum OrderStatus
{
	OrderStatus_Unknown = 0,
	OrderStatus_New = 1,                   //ѱ
	OrderStatus_PartiallyFilled = 2,       //
	OrderStatus_Filled = 3,                //ѳ
	OrderStatus_DoneForDay = 4,            //
	OrderStatus_Canceled = 5,              //ѳ
	OrderStatus_PendingCancel = 6,         //
	OrderStatus_Stopped = 7,               //
	OrderStatus_Rejected = 8,              //Ѿܾ
	OrderStatus_Suspended = 9,             //
	OrderStatus_PendingNew = 10,           //
	OrderStatus_Calculated = 11,           //
	OrderStatus_Expired = 12,              //ѹ
	OrderStatus_AcceptedForBidding = 13,   //
	OrderStatus_PendingReplace = 14,       //
};

//ִлر
enum ExecType
{
	ExecType_Unknown = 0,
	ExecType_New = 1,                      //ѱ
	ExecType_DoneForDay = 4,               //
	ExecType_Canceled = 5,                 //ѳ
	ExecType_PendingCancel = 6,            //
	ExecType_Stopped = 7,                  //
	ExecType_Rejected = 8,                 //Ѿܾ
	ExecType_Suspended = 9,                //
	ExecType_PendingNew = 10,              //
	ExecType_Calculated = 11,              //
	ExecType_Expired = 12,                 //
	ExecType_Restated = 13,                //
	ExecType_PendingReplace = 14,          //
	ExecType_Trade = 15,                   //ɽ
	ExecType_TradeCorrect = 16,            //
	ExecType_TradeCancel = 17,             //
	ExecType_OrderStatus = 18,             //ί״̬
	ExecType_CancelRejected = 19,          //ܾ
};

//ίоܾԭ
enum OrderRejectReason
{
	OrderRejectReason_Unknown = 0,                           //δ֪ԭ
	OrderRejectReason_RiskRuleCheckFailed = 1,               //Ϸع 
	OrderRejectReason_NoEnoughCash = 2,                      //ʽ
	OrderRejectReason_NoEnoughPosition = 3,                  //λ
	OrderRejectReason_IllegalAccountId = 4,                  //Ƿ˻ID
	OrderRejectReason_IllegalStrategyId = 5,                 //ǷID
	OrderRejectReason_IllegalSymbol = 6,                     //Ƿ״
	OrderRejectReason_IllegalVolume = 7,                     //Ƿί
	OrderRejectReason_IllegalPrice = 8,                      //Ƿίм
	OrderRejectReason_AccountDisabled = 10,                  //˺űֹ
	OrderRejectReason_AccountDisconnected = 11,              //˺δ
	OrderRejectReason_AccountLoggedout = 12,                 //˺δ¼
	OrderRejectReason_NotInTradingSession = 13,              //ǽʱ
	OrderRejectReason_OrderTypeNotSupported = 14,            //ίͲ֧
	OrderRejectReason_Throttle = 15,                         //
	OrderRejectReason_SymbolSusppended = 16,                 //״ͣ
	OrderRejectReason_Internal = 999,                        //ڲ

	CancelOrderRejectReason_OrderFinalized = 101,            //ί
	CancelOrderRejectReason_UnknownOrder = 102,              //δ֪ί
	CancelOrderRejectReason_BrokerOption = 103,              //̨
	CancelOrderRejectReason_AlreadyInPendingCancel = 104,    //ίг
};

//ίз
enum OrderSide
{
	OrderSide_Unknown = 0,
	OrderSide_Buy = 1,    //
	OrderSide_Sell = 2,    //
};

//ί
enum OrderType
{
	OrderType_Unknown = 0,
	OrderType_Limit = 1,    //޼ί
	OrderType_Market = 2,    //мί
	OrderType_Stop = 3,    //ֹֹӯί
};

//ίʱ
enum OrderDuration
{
	OrderDuration_Unknown = 0,
	OrderDuration_FAK = 1,  //ʱɽʣ೷(fill and kill)
	OrderDuration_FOK = 2,  //ʱȫɽ(fill or kill)
	OrderDuration_GFD = 3,  //Ч(good for day)
	OrderDuration_GFS = 4,  //Ч(good for section)
	OrderDuration_GTD = 5,  //ָǰЧ(goodl till date)
	OrderDuration_GTC = 6,  //ǰЧ(good till cancel)
	OrderDuration_GFA = 7,  //ϾǰЧ(good for auction)
};

//ίгɽ
enum OrderQualifier
{
	OrderQualifier_Unknown = 0,
	OrderQualifier_BOC = 1,  //Էż۸(best of counterparty)
	OrderQualifier_BOP = 2,  //ż۸(best of party)
	OrderQualifier_B5TC = 3,  //嵵ʣ೷(best 5 then cancel)
	OrderQualifier_B5TL = 4,  //嵵ʣת޼(best 5 then limit)
};

//ֲַ
enum PositionSide
{
	PositionSide_Unknown = 0,
	PositionSide_Long = 1,   //෽
	PositionSide_Short = 2,   //շ
};

//ƽ־
enum PositionEffect
{
	PositionEffect_Unknown = 0,
	PositionEffect_Open = 1,     //
	PositionEffect_Close = 2,     //ƽ,ȡڶӦĽ
	PositionEffect_CloseToday = 3,     //ƽ
	PositionEffect_CloseYesterday = 4,     //ƽ
};

//ʽֱֲԭ
enum CashPositionChangeReason
{
	CashPositionChangeReason_Unknown = 0,
	CashPositionChangeReason_Trade = 1,  //
	CashPositionChangeReason_Inout = 2,  ///ֲ
	CashPositionChangeReason_Dividend = 3,  //ֺ͹
};

enum AccountState
{
	State_UNKNOWN = 0,       //δ֪
	State_CONNECTING = 1,    //
	State_CONNECTED = 2,     //
	State_LOGGEDIN = 3,      //ѵ¼
	State_DISCONNECTING = 4, //Ͽ
	State_DISCONNECTED = 5,  //ѶϿ
	State_ERROR = 6          //
};

//㷨״̬,ͣ/ָ㷨ʱЧ
enum AlgoOrderStatus 
{
	AlgoOrderStatus_Unknown = 0,
	AlgoOrderStatus_Resume = 1,                  //ָĸ
	AlgoOrderStatus_Pause = 2,                   //ͣĸ
	AlgoOrderStatus_PauseAndCancelSubOrders = 3  //ĸӵ
};

//ͷԴ(ȯȯ)
enum PositionSrc
{
	PositionSrc_Unknown = 0,
	PositionSrc_L1 = 1,          //ͨ
	PositionSrc_L2 = 2           //ר
};

//֤ȯ
enum SecurityType
{
	SecurityType_Unknown = 0,
	SecurityType_Stock = 1,  //Ʊ
	SecurityType_Fund = 2,   //
	SecurityType_Index = 3,  //ָ
	SecurityType_Future = 4,  //ڻ
	SecurityType_Option = 5,  //Ȩ
	SecurityType_Credit = 6,  //
	SecurityType_Bond = 7,    //ծȯ
	SecurityType_Bond_Convertible = 8 //ծȯ
};

//ҵ
enum OrderBusiness
{
	OrderBusiness_NORMAL = 0,                         //ͨ                                                           
	OrderBusiness_IPO_BUY = 100,                      //¹깺                                                         
	OrderBusiness_CREDIT_BOM = 200,                   //(buying on margin)                                       
	OrderBusiness_CREDIT_SS = 201,                    //ȯ(short selling)                                          
	OrderBusiness_CREDIT_RSBBS = 202,                 //ȯȯ(repay share by buying share)                            
	OrderBusiness_CREDIT_RCBSS = 203,                 //ȯ(repay cash by selling share)                            
	OrderBusiness_CREDIT_DRS = 204,                   //ֱӻȯ(directly repay share)                                   
	OrderBusiness_CREDIT_DRC = 211,                   //ֱӻ(directly repay cash)                                    
	OrderBusiness_CREDIT_CPOM = 205,                  //ƽ(close position on margin)                               
	OrderBusiness_CREDIT_CPOSS = 206,                 //ȯƽ(close position on short selling)                        
	OrderBusiness_CREDIT_BOC = 207,                   //Ʒ(buying on collateral)                                 
	OrderBusiness_CREDIT_SOC = 208,                   //Ʒ(selling on collateral)                                
	OrderBusiness_CREDIT_CI = 209,                    //Ʒת(collateral in)                                        
	OrderBusiness_CREDIT_CO = 210,                    //Ʒת(collateral out)                                       
	OrderBusiness_ETF_BUY = 301,                      //ETF깺(purchase)                                                
	OrderBusiness_ETF_RED = 302,                      //ETF(redemption)                                              
	OrderBusiness_FUND_SUB = 303,                     //Ϲ(subscribing)                                            
	OrderBusiness_FUND_BUY = 304,                     //깺(purchase)                                               
	OrderBusiness_FUND_RED = 305,                     //(redemption)                                             
	OrderBusiness_FUND_CONVERT = 306,                 //ת(convert)                                                
	OrderBusiness_FUND_SPLIT = 307,                   //ֲ(split)                                                  
	OrderBusiness_FUND_MERGE = 308,                   //ϲ(merge)                                                  
	OrderBusiness_BOND_RRP = 400,                     //ծȯع(reverse repurchase agreement (RRP) or reverse repo)   
	OrderBusiness_BOND_CONVERTIBLE_BUY = 401,         //תծ깺(purchase)                                             
	OrderBusiness_BOND_CONVERTIBLE_CALL = 402,        //תծת                                                       
	OrderBusiness_BOND_CONVERTIBLE_PUT = 403,         //תծ                                                       
	OrderBusiness_BOND_CONVERTIBLE_PUT_CANCEL = 404   //תծ۳                                                   
};

typedef char Symbol[LEN_SYMBOL];
typedef char TradingDate[LEN_ISO_DATATIME];

struct Bar
{
	char                    symbol[LEN_SYMBOL];
	double                  bob;                          ///barĿʼʱ
	double                  eob;                          ///barĽʱ
	float                   open;                         ///<̼
	float                   close;                        ///<̼
	float                   high;                         ///<߼
	float                   low;                          ///<ͼ
	double                  volume;                       ///<ɽ
	double                  amount;                       ///<ɽ
	float                   pre_close;                    ///ֻ̼ۣƵݸֵ

	long long               position;                     ///<ֲ
	char                    frequency[LEN_FREQUENCY];     ///barƵ
};

struct Quote
{
	float      bid_price;                            ///ί
	long long  bid_volume;                           ///ί
	float      ask_price;                            ///ί
	long long  ask_volume;                           ///ί
};

struct Tick
{
	char                   symbol[LEN_SYMBOL];
	double                 created_at;               ///<utcʱ䣬ȷ
	float                  price;                    ///<¼
	float                  open;                     ///<̼
	float                  high;                     ///<߼
	float                  low;                      ///<ͼ
	double                 cum_volume;               ///<ɽ
	double                 cum_amount;               ///<ɽܽ/³ɽ,ۼֵ
	long long              cum_position;             ///<Լֲ(),ۼֵ
	double                 last_amount;              ///<˲ʱɽ
	int                    last_volume;              ///<˲ʱɽ
	int                    trade_type;               ///(),Ӧ࿪,ƽ
	Quote                  quotes[DEPTH_OF_QUOTE];   ///, ±0ʼ0-ʾһ1-ʾڶ

};

struct L2Transaction
{
	char                   symbol[LEN_SYMBOL];
	double                 created_at;               ///ɽʱ䣬utcʱ
	float                  price;                    ///ɽ
	long long              volume;					 ///ɽ
	char                   side;                     ///̱
	char                   exec_type;                ///ɽ
	long long              exec_index;               ///ɽ
	long long              ask_order_index;          ///ίб
	long long              bid_order_index;          ///ίб
};

struct L2Order
{
	char                   symbol[LEN_SYMBOL];
	double                 created_at;               ///ίʱ䣬utcʱ
	float                  price;                    ///ίм
	long long              volume;					 ///ί
	char                   side;                     ///
	char                   order_type;               ///ί
	long long              order_index;              ///ίб
};

struct L2OrderQueue
{
	char                   symbol[LEN_SYMBOL];
	double                 created_at;                                  ///ʱ䣬utcʱ
	float                  price;                                       ///ίм
	long long              volume;					                    ///ί
	char                   side;                                        ///
	int                    queue_orders;                                ///ίԪظ(50)
	int                    queue_volumes[LEN_MAX_ORDER_QUEUE];          ///ί(50пС50, Чݳȡqueue_orders)
};

struct VarietyInfo
{
	char     variety_name[LEN_NAME];          //Ʒƣȫдǰ׺
	int      sec_type;                        //Ʒ
	int      sec_type_ext;                    //Ʒչ
	char     exchange[LEN_EXCHANGE];          //
	char     quote_unit[LEN_TYPE];            //۵λ
	double   price_tick;                      //С䶯λ  
	double   multiplier;                      //"Լ (ƱȨĺԼλƷȨĽ׵λָȨĺԼ"
	int      trade_n;                         //ƶȣ0ʾT+01ʾT+12ʾT+2
	char     option_type;                     //ȨʽE:ŷʽA:ʽ 
};


struct Order
{
	char         strategy_id[LEN_ID];                     //ID                                      
	char         account_id[LEN_ID];                      //˺ID                                      
	char         account_name[LEN_NAME];                  //˻¼                                  

	char         cl_ord_id[LEN_ID];                       //ίпͻID                                
	char         order_id[LEN_ID];                        //ίй̨ID                     
	char         ex_ord_id[LEN_ID];                       //ίнID   
	char         algo_order_id[LEN_ID];                   //㷨ĸID
	int          order_business;                          //ҵ

	char         symbol[LEN_SYMBOL];                      //symbol                                      
	int          side;                                    //ȡֵοenum OrderSide            
	int          position_effect;                         //ƽ־ȡֵοenum PositionEffect       
	int          position_side;                           //ֲַȡֵοenum PositionSide         

	int          order_type;                              //ίͣȡֵοenum OrderType            
	int          order_duration;                          //ίʱԣȡֵοenum OrderDuration    
	int          order_qualifier;                         //ίгɽԣȡֵοenum OrderQualifier   
	int          order_src;                               //ίԴȡֵοenum OrderSrc   
	int          position_src;                            //ͷԴȯȡֵο enum PositionSrc

	int          status;                                  //ί״̬ȡֵοenum OrderStatus          
	int          ord_rej_reason;                          //ίоܾԭȡֵοenum OrderRejectReason
	char         ord_rej_reason_detail[LEN_INFO];         //ίоܾԭ                            

	double       price;                                   //ίм۸                                    
	double       stop_price;                              //ίֹ/ֹӯ۸                       

	int          order_style;                             //ίзȡֵο enum OrderStyle          
	long long    volume;                                  //ί                                      
	double       value;                                   //ίж                                      
	double       percent;                                 //ίаٷֱ                                  
	long long    target_volume;                           //ίĿ                                  
	double       target_value;                            //ίĿ                                  
	double       target_percent;                          //ίĿٷֱ                              

	long long    filled_volume;                           //ѳ                                      
	double       filled_vwap;                             //ѳɾ                                    
	double       filled_amount;                           //ѳɽ                                    
	double       filled_commission;                       //ѳ                                  

	long long    created_at;                              //ίдʱ                                
	long long    updated_at;                              //ίиʱ  
};

struct AlgoOrder
{
	char         strategy_id[LEN_ID];                     //ID                                      
	char         account_id[LEN_ID];                      //˺ID                                      
	char         account_name[LEN_NAME];                  //˻¼                                  

	char         cl_ord_id[LEN_ID];                       //ίпͻID                                
	char         order_id[LEN_ID];                        //ίй̨ID                                  
	char         ex_ord_id[LEN_ID];                       //ίнID
	int          order_business;                          //ҵ

	char         symbol[LEN_SYMBOL];                      //symbol                                      
	int          side;                                    //ȡֵοenum OrderSide            
	int          position_effect;                         //ƽ־ȡֵοenum PositionEffect       
	int          position_side;                           //ֲַȡֵοenum PositionSide         

	int          order_type;                              //ίͣȡֵοenum OrderType            
	int          order_duration;                          //ίʱԣȡֵοenum OrderDuration    
	int          order_qualifier;                         //ίгɽԣȡֵοenum OrderQualifier   
	int          order_src;                               //ίԴȡֵοenum OrderSrc    
	int          position_src;                            //ͷԴȯȡֵο enum PositionSrc

	int          status;                                  //ί״̬ȡֵοenum OrderStatus          
	int          ord_rej_reason;                          //ίоܾԭȡֵοenum OrderRejectReason
	char         ord_rej_reason_detail[LEN_INFO];         //ίоܾԭ                            

	double       price;                                   //ίм۸                                    
	double       stop_price;                              //ίֹ/ֹӯ۸                       

	int          order_style;                             //ίзȡֵο enum OrderStyle          
	long long    volume;                                  //ί                                      
	double       value;                                   //ίж                                      
	double       percent;                                 //ίаٷֱ                                  
	long long    target_volume;                           //ίĿ                                  
	double       target_value;                            //ίĿ                                  
	double       target_percent;                          //ίĿٷֱ                              

	long long    filled_volume;                           //ѳ                                      
	double       filled_vwap;                             //ѳɾ                                    
	double       filled_amount;                           //ѳɽ                                    
	double       filled_commission;                       //ѳ     

	char         algo_provider[LEN_NAME];                 //㷨AppID
	char         algo_name[LEN_NAME];                     //㷨
	char         algo_param[LEN_PARAM];                   //㷨Բ
	int          algo_status;                             //㷨״̬,ΪAlgoOrder PauseΣȡֵο enum AlgoOrderStatus
	char         algo_comment[LEN_COMMENT];               //㷨ע

	long long    created_at;                              //ίдʱ                                
	long long    updated_at;                              //ίиʱ  
};

struct ExecRpt
{
	char               strategy_id[LEN_ID];                  //ID                                                                                                        
	char               account_id[LEN_ID];                   //˺ID                                                       
	char               account_name[LEN_NAME];               //˻¼                                                                                                    

	char               cl_ord_id[LEN_ID];                    //ίпͻID                                                                                                  
	char               order_id[LEN_ID];                     //ίй̨ID                                                                                                    
	char               exec_id[LEN_ID];                      //ίлرID                                                                                                    

	char               symbol[LEN_SYMBOL];                   //symbol                                                                                                        

	int                position_effect;                      //ƽ־ȡֵοenum PositionEffect                                                                         
	int                side;                                 //ȡֵοenum OrderSide                                                                              
	int                ord_rej_reason;                       //ίоܾԭȡֵοenum OrderRejectReason                                                                  
	char               ord_rej_reason_detail[LEN_INFO];      //ίоܾԭ                                                                                              
	int                exec_type;                            //ִлر, ȡֵοenum ExecType                                                                           

	double             price;                                //ίгɽ۸                                                                                                  
	long long          volume;                               //ίгɽ                                                                                                    
	double             amount;                               //ίгɽ                                                                                                  
	double             commission;                           //ίгɽ                                                                                                
	double             cost;                                 //ίгɽɱ  
	long long          created_at;                           //رʱ

};

struct Cash
{
	char          account_id[LEN_ID];                        //˺ID               
	char          account_name[LEN_NAME];                    //˻¼                                                                   

	int           currency;                                  //                                                                         

	double        nav;                                        //ֵ(cum_inout + cum_pnl + fpnl - cum_commission)                            
	double        pnl;                                        //(nav-cum_inout)                                                        
	double        fpnl;                                       //ӯ(sum(each position fpnl))                                            
	double        frozen;                                     //ֲռʽ                                                                 
	double        order_frozen;                               //ҵʽ                                                                 
	double        available;                                  //ʽ                                                                     
															  //no  leverage:  available=(cum_inout + cum_pnl - cum_commission - frozen - order_frozen)        
															  //has leverage:  fpnl     =(fpnl>0 ? fpnl : (frozen < |fpnl|) ? (frozen-|fpnl|) : 0)             
															  //               available=(cum_inout + cum_pnl - cum_commission - frozen - order_frozen + fpnl) 
	double        balance;                                    //ʽ                                                                     
	double        market_value;                               //ֲֵ
	double        market_value_long;                          //Ȩֵ(Ȩ)
	double        market_value_short;                         //ֵ(Ȩ)
	double        used_bail;                                  //ñ֤(Ȩ)
	double        enable_bail;                                //ñ֤(Ȩ)
	double        cum_inout;                                  //ۼƳ                                                                   
	double        cum_trade;                                  //ۼƽ׶                                                                   
	double        cum_pnl;                                    //ۼƽ(û۳)                                                   
	double        cum_commission;                             //ۼ                                                                   

	double        last_trade;                                 //һν׶                                                                 
	double        last_pnl;                                   //һ                                                                   
	double        last_commission;                            //һ                                                                 
	double        last_inout;                                 //һγ                                                                 
	int           change_reason;                              //ʽԭȡֵοenum CashPositionChangeReason                          
	char          change_event_id[LEN_ID];                    //ʽ¼ID     

	long long     created_at;                                 //ʽʼʱ
	long long     updated_at;                                 //ʽʱ

};

struct Position
{
	char                 account_id[LEN_ID];              //˺ID                                       
	char                 account_name[LEN_NAME];          //˻¼                                                                                       

	char                 symbol[LEN_SYMBOL];              //symbol                                       
	int                  side;                            //ֲַȡֵοenum PositionSide          
	long long            volume;                          //ֲܳ; ֲ(volume-volume_today)                                                          
	long long            volume_today;                    //ճֲ                                                                                       
	double               vwap;                            //ֲ־(ƱΪڿּ۵ĳֲ־ۣڻΪڽ۵ĳֲ־)  
	double               vwap_diluted;                    //̯ɱ
	double               vwap_open;                       //ڿּ۵ĳֲ־(ڻ)
	double               amount;                          //ֲֶ(volume*vwap*multiplier)                                                                   

	double               price;                           //ǰ۸                                                                                     
	double               fpnl;                            //ֲָӯ((price-vwap)*volume*multiplier) 
	double               fpnl_diluted;                    //ֲָӯ,ڳֲ־((price-vwap_diluted)*volume*multiplier)
	double               fpnl_open;                       //ֲָӯ,ڿ־ۣڻ((price-vwap_open)*volume*multiplier)
	double               cost;                            //ֲֳɱ(vwap*volume*multiplier*margin_ratio)                                                    
	long long            order_frozen;                    //ҵλ                                                                                     
	long long            order_frozen_today;              //ҵֲλ                                                                                 
	long long            available;                       //ܲλ(volume-order_frozen); λ(available-available_today)                           
	long long            available_today;                 //ýλ(volume_today-order_frozen_today)
	long long            available_now;                   //ǰƽλ
	long long            credit_position_sellable_volume; //Ʒλ()
	double               market_value;                    //ֲֵ

	double               last_price;                      //һγɽ                                                                                     
	long long            last_volume;                     //һγɽ                                                                                     
	long long            last_inout;                      //һγֲ                                                                                 
	int                  change_reason;                   //λԭȡֵοenum CashPositionChangeReason                                              
	char                 change_event_id[LEN_ID];         //ʽ¼ID                                                                             

	int                  has_dividend;                    //ֲзֺ   
	long long            created_at;                      //ʱ
	long long            updated_at;                      //λʱ

};

struct Account 
{
	char            account_id[LEN_ID];           //˺ID
	char            account_name[LEN_NAME];       //˻¼
	char            title[LEN_NAME];              //˺
	char            intro[LEN_INFO];              //˺
	char            comment[LEN_INFO];            //˺űע
};

struct AccountStatus
{
	char            account_id[LEN_ID];           //˺ID
	char            account_name[LEN_NAME];       //˻¼
	int             state;                        //˻״̬
	int             error_code;                   //
	char            error_msg[LEN_INFO];          //Ϣ
};

struct Parameter
{
	char   key[LEN_ID];          //
	double value;                //ֵ
	double min;                  //õСֵ
	double max;                  //õֵ
	char   name[LEN_NAME];       //
	char   intro[LEN_INFO];      //˵
	char   group[LEN_NAME];      //
	bool   readonly;             //Ƿֻ
};

struct Indicator
{
	char      account_id[LEN_ID];             //˺ID
	double    pnl_ratio;                      //ۼ(pnl/cum_inout)
	double    pnl_ratio_annual;               //껯
	double    sharp_ratio;                    //ձ
	double    max_drawdown;                   //س
	double    risk_ratio;                     //ձ
	int       open_count;                     //ִ
	int       close_count;                    //ƽִ
	int       win_count;                      //ӯ
	int       lose_count;                     //
	double    win_ratio;                      //ʤ

	long long  created_at;                    //ָ괴ʱ
	long long  updated_at;                    //ָʱ
};

struct CollateralInstrument
{
	char                 symbol[LEN_SYMBOL];  //֤ȯ
	char                 name[LEN_NAME];      //
	double               pledge_rate;         //
};

struct BorrowableInstrument
{
	char                 symbol[LEN_SYMBOL];        //֤ȯ
	char                 name[LEN_NAME];            //
	double               margin_rate_for_cash;      //ʱ֤
	double               margin_rate_for_security;  //ȯ֤
};

struct BorrowableInstrumentPosition
{
	char                 symbol[LEN_SYMBOL];        //֤ȯ
	char                 name[LEN_NAME];            //
	double               balance;                   //֤ȯ
	double               available;                 //֤ȯ
};

struct CreditContract
{
	char symbol[LEN_SYMBOL];              //֤ȯ stkcode    
	char name[LEN_NAME];                  //
	int orderdate;                        //ί                   
	char ordersno[LEN_ID];                //ί                     
	char creditdirect;                    //ȯ               
	double orderqty;                      //ί                   
	double matchqty;                      //ɽ                   
	double orderamt;                      //ίн                   
	double orderfrzamt;                   //ίж               
	double matchamt;                      //ɽ                   
	double clearamt;                      //                   
	char lifestatus;                      //Լ״̬                   
	int enddate;                          //ծֹ               
	int oldenddate;                       //ԭʼĸծֹ         
	double creditrepay;                   //T֮ǰ黹            
	double creditrepayunfrz;              //Tչ黹                
	double fundremain;                    //Ӧ                   
	double stkrepay;                      //T֮ǰ黹            
	double stkrepayunfrz;                 //Tչ黹                
	double stkremain;                     //Ӧ֤ȯ               
	double stkremainvalue;                //Ӧ֤ȯֵ               
	double fee;                           //ȯϢ             
	double overduefee;                    //δϢ           
	double fee_repay;                     //Ϣ               
	double punifee;                       //ϢķϢ             
	double punifee_repay;                 //Ϣ                 
	double rights;                        //δȨ             
	double overduerights;                 //δȨ             
	double rights_repay;                  //Ȩ                 
	double lastprice;                     //¼                     
	double profitcost;                    //ӯ                   
	int sysdate;                          //ϵͳ                   
	char sno[LEN_ID];                     //Լ                   
	int lastdate;                         //һμϢ       
	int closedate;                        //Լȫ           
	double punidebts;                     //ڱϢ               
	double punidebts_repay;               //Ϣ               
	double punidebtsunfrz;                //ڱϢ               
	double punifeeunfrz;                  //ϢѷϢ               
	double punirights;                    //Ȩ淣Ϣ               
	double punirights_repay;              //Ȩ淣Ϣ               
	double punirightsunfrz;               //Ȩ淣Ϣ               
	double feeunfrz;                      //ʵʱϢ               
	double overduefeeunfrz;               //ʵʱϢ           
	double rightsqty;                     //δȨ             
	double overduerightsqty;              //δȨ    
};


struct CreditCash
{
	double fundintrrate;                        //                 
	double stkintrrate;                         //ȯ                 
	double punishintrrate;                      //Ϣ                 
	char   creditstatus;                        //״̬                 
	double marginrates;                         //άֵ             
	double realrate;                            //ʵʱ             
	double asset;                               //ʲ                   
	double liability;                           //ܸծ                   
	double marginavl;                           //֤             
	double fundbal;                             //ʽ                 
	double fundavl;                             //ʽ               
	double dsaleamtbal;                         //ȯʽ         
	double guaranteeout;                        //תʲ           
	double gagemktavl;                          //֤ȯֵ             
	double fdealavl;                            //ʱ                 
	double ffee;                                //Ϣ                 
	double ftotaldebts;                         //ʸծϼ             
	double dealfmktavl;                         //Ӧȯֵ             
	double dfee;                                //ȯϢ                 
	double dtotaldebts;                         //ȯծϼ             
	double fcreditbal;                          //Ŷ             
	double fcreditavl;                          //ʿö             
	double fcreditfrz;                          //ʶȶ             
	double dcreditbal;                          //ȯŶ             
	double dcreditavl;                          //ȯö             
	double dcreditfrz;                          //ȯȶ             
	double rights;                              //Ȩ                 
	double serviceuncomerqrights;               //Ȩ(;)           
	double rightsqty;                           //Ȩ                 
	double serviceuncomerqrightsqty;            //Ȩ(;)           
	double acreditbal;                          //ܶ                   
	double acreditavl;                          //ܿö               
	double acashcapital;                        //ֽʲʲȯ     
	double astkmktvalue;                        //֤ȯֵ롢ǵƷ     
	double withdrawable;                        //ȡʽ                                   
	double netcapital;                          //ʲ                                     
	double fcreditpnl;                          //ӯ                                   
	double dcreditpnl;                          //ȯӯ                                   
	double fcreditmarginoccupied;               //ռñ֤                             
	double dcreditmarginoccupied;               //ȯռñ֤                             
	double collateralbuyableamt;                //򵣱Ʒʽ                             
	double repayableamt;                        //ɻ                                 
	double dcreditcashavl;                      //ȯʽ     
};

//¹깺
struct IPOQI
{
	char exchange[LEN_TYPE];        //г
	double quota;                   //г
	double sse_star_quota;          //Ϻƴ
};

struct IPOInstruments
{
	char     symbol[LEN_SYMBOL];     //깺¹symbol
	double   price;                  //깺۸
	int      min_vol;                //깺С
	int      max_vol;                //깺
};

struct IPOMatchNumber
{
	char order_id[LEN_ID];           //ίк
	char symbol[LEN_SYMBOL];         //¹symbol
	int   volume;                    //ɽ
	char match_number[LEN_ID];       //깺
	int  order_at;                   //ί
	int  match_at;                    //
};

struct IPOLotInfo
{
	char symbol[LEN_SYMBOL];   //¹symbol   
	int order_at;              //ί     
	int lot_at;                //ǩ     
	int lot_volume;            //ǩ     
	int give_up_volume;        //     
	double price;              //ǩ۸     
	double amount;             //ǩ     
	double pay_volume;         //ѽɿ   
	double pay_amount;         //ѽɿ   

};

struct SmartReorderParameter
{
	char      symbol[LEN_SYMBOL];
	double    price;
	int       volume;
	int       side;
	int       order_type;
	int       position_effect;
	int       repeat_n;
	int       max_price_offset;
	int       time_out;
	int       time_wait;
	char      account_id[LEN_ID];             //˺ID
	int       reorder_id;                     //:رܵID, ڳܵ
};

struct OptionPreorderValidVolumeRequest
{
	char      symbol[LEN_SYMBOL];
	double    price;
	int       side;
	int       covered_flag;
	char      account_id[LEN_ID];             //˺ID
};

struct OptionPreorderSellMarginRequest
{
	char      symbol[LEN_SYMBOL];
	char      account_id[LEN_ID];             //˺ID
};

struct TradingTimes
{
	char       variety_name[LEN_ID];                     //ƷID
	char       time_trading[LEN_TIME_LIST];              //ʱ
	char       time_callauction[LEN_TIME_LIST];          //Ͼʱ
};

struct BacktestConfig 
{
	BacktestConfig()
	{
		initial_cash = 1000000;
		transaction_ratio = 1;
		commission_ratio = 0;
		commission_unit = 0;
		slippage_ratio = 0;
		option_float_margin_ratio1 = 0.2;
		option_float_margin_ratio2 = 0.4;
		adjust = 0;
		match_mode = 0;
		check_cache = 1;
	}

	char   start_time[LEN_ISO_DATATIME];
	char   end_time[LEN_ISO_DATATIME];
	double initial_cash;
	double transaction_ratio;
	double commission_ratio;
	double commission_unit;
	double slippage_ratio;
	double option_float_margin_ratio1;
	double option_float_margin_ratio2;
	int    adjust;
	int    match_mode;
	int    check_cache;
};

#endif
